//+------------------------------------------------------------------+
//|                                                  .mq4 |
//|                                                          pilgrim |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "pilgrim"

extern int MinProfit = 5;
extern int TrailingStop = 30;
extern int TrailingStep = 5;

int start()
{
  int cnt = OrdersTotal();
  for (int i=0; i<cnt; i++) {
    if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) continue;

    if (OrderSymbol() != Symbol()) continue;
    //if (OrderMagicNumber() != Magic) continue;
    
    if (OrderType() == OP_BUY) {
      if (Bid-OrderOpenPrice() > MinProfit*Point) {
        if (OrderStopLoss() < Bid-(TrailingStop+TrailingStep-1)*Point) {
          OrderModify(OrderTicket(), OrderOpenPrice(), Bid-TrailingStop*Point, OrderTakeProfit(), 0, Blue);
        }
      }
    }
    
    if (OrderType() == OP_SELL) {
      if (OrderOpenPrice()-Ask > MinProfit*Point) {
        if (OrderStopLoss() > Ask+(TrailingStop+TrailingStep-1)*Point || OrderStopLoss() == 0) {
          OrderModify(OrderTicket(), OrderOpenPrice(), Ask+TrailingStop*Point, OrderTakeProfit(), 0, Blue);
        }
      }
    }
  }
   return(0);
  }
//+------------------------------------------------------------------+

